// Sample8_SecureFlashContentLoadingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sample8_SecureFlashContentLoading.h"
#include "Sample8_SecureFlashContentLoadingDlg.h"
#include ".\Sample8_SecureFlashContentLoadingdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSample8_SecureFlashContentLoadingDlg dialog

static HRESULT WINAPI GlobalOnLoadExternalResourceHandler(LPCSTR lpszURL, IStream** ppStream);
static DWORD WINAPI FlashContentProviderThread(LPVOID lpParameter);

static CString g_strFlashFilePath;

CSample8_SecureFlashContentLoadingDlg::CSample8_SecureFlashContentLoadingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSample8_SecureFlashContentLoadingDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSample8_SecureFlashContentLoadingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSample8_SecureFlashContentLoadingDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(ID_SITE, OnBnClickedSite)
	ON_BN_CLICKED(ID_ORDER, OnBnClickedOrder)
	ON_BN_CLICKED(ID_CRYPT, OnBnClickedCrypt)
	ON_BN_CLICKED(ID_PLAY, OnBnClickedPlay)
END_MESSAGE_MAP()


// CSample8_SecureFlashContentLoadingDlg message handlers

BOOL CSample8_SecureFlashContentLoadingDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	// FlashPlayerControl creating
	// NOTE: CALL RegisterFlashWindowClass() or RegisterFlashWindowClassEx() before creating!
	// See InitInstance() implementation
	{
		RECT rc;
		GetDlgItem(IDC_STATIC_FPC_PLACE)->GetWindowRect(&rc);
		ScreenToClient(&rc);

		m_hwndFlashPlayerControl = 
			CreateWindow(WC_FLASH, 
						 NULL, 
						 WS_CHILD | WS_VISIBLE, 
						 rc.left, 
						 rc.top, 
						 rc.right - rc.left, 
						 rc.bottom - rc.top, 
						 m_hWnd, 
						 NULL, 
						 NULL, 
						 NULL);
	}

	FPCSetGlobalOnLoadExternalResourceHandler(&GlobalOnLoadExternalResourceHandler);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSample8_SecureFlashContentLoadingDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSample8_SecureFlashContentLoadingDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSample8_SecureFlashContentLoadingDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

/*
void CSample8_SecureFlashContentLoadingDlg::OnBnClickedPlaySWFFromFile()
{
    CFileDialog dlg(TRUE, 
                    _T("swf"), 
                    _T(""), 
                    0, 
                    _T("Flash movie files (*.swf)|*.swf|All Files (*.*)|*.*||"), 
                    this, 
                    0);

    if (IDOK == dlg.DoModal())
    {
        //
        CString strFlashMoviePath = dlg.GetPathName();

        //
        TCHAR lpszFlashMoviePath[MAX_PATH + 1] = { 0 };
        lstrcpy(lpszFlashMoviePath, strFlashMoviePath);

        //
        SFPCPutMovie SFPCPutMovie;
        SFPCPutMovie.lpszBuffer = lpszFlashMoviePath;
        ::SendMessage(m_hwndFlashPlayerControl, FPCM_PUT_MOVIE, 0, (LPARAM)&SFPCPutMovie);
    }
}

void CSample8_SecureFlashContentLoadingDlg::OnBnClickedPlayFLVFromFile()
{
    CFileDialog dlg(TRUE, 
                    _T("flv"), 
                    _T(""), 
                    0, 
                    _T("Flash video files (*.flv)|*.flv|All Files (*.*)|*.*||"), 
                    this, 
                    0);

    if (IDOK == dlg.DoModal())
	{
        //
        g_strFLVPath = dlg.GetPathName();

        //
		FPCPutMovieFromResource(m_hwndFlashPlayerControl, 0, _T("FLVPlayer"), _T("SWF"));
    }
}
*/

void CSample8_SecureFlashContentLoadingDlg::OnBnClickedSite()
{
	ShellExecute(m_hWnd, NULL, _T("http://www.flashplayercontrol.com/dll/"), NULL, NULL, SW_SHOW);
}

void CSample8_SecureFlashContentLoadingDlg::OnBnClickedOrder()
{
	ShellExecute(m_hWnd, NULL, _T("http://www.flashplayercontrol.com/dll/order.html"), NULL, NULL, SW_SHOW);
}

void CSample8_SecureFlashContentLoadingDlg::OnBnClickedCrypt()
{
	AfxMessageBox(_T("Select flash movie or flash video file for crypting"));

	CString strInputFile;
	{
		CFileDialog dlg(TRUE, 
						_T("swf"), 
						_T(""), 
						0, 
						_T("Flash files (*.swf;*.flv)|*.swf;*.flv|All Files (*.*)|*.*||"), 
						this, 
						0);

		if (IDOK == dlg.DoModal())
			strInputFile = dlg.GetPathName();
		else
			return;
	}

	AfxMessageBox(_T("Select where to save a crypted file"));

	CString strOutputFile;
	{
		CFileDialog dlg(FALSE, 
						_T("crypted"), 
						strInputFile + _T(".crypted"), 
						OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
						_T("Crypted Flash files (*.crypted)|*.crypted;*.crypted|All Files (*.*)|*.*||"), 
						this, 
						0);

		if (IDOK == dlg.DoModal())
			strOutputFile = dlg.GetPathName();
		else
			return;
	}

	if (IDOK != 
		AfxMessageBox(_T("This is a demo application. That's why the crypting is very simple (XOR)\nPress OK to start"), MB_OKCANCEL))
		return;

	HANDLE hFile__Input = CreateFile(strInputFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	HANDLE hFile__Output = CreateFile(strOutputFile, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 0, NULL);

	char Buffer[1024];
	BOOL bRes;
	DWORD dwNumberOfBytesRead, dwNumberOfBytesWritten;

	while (true)
	{
		bRes = ReadFile(hFile__Input, Buffer, sizeof(Buffer), &dwNumberOfBytesRead, NULL);

		if (!bRes || 0 == dwNumberOfBytesRead)
			break;

		// Very-very simple crypting
		for (DWORD i = 0; i < dwNumberOfBytesRead; i++)
			Buffer[i] ^= 0x06;

		WriteFile(hFile__Output, Buffer, dwNumberOfBytesRead, &dwNumberOfBytesWritten, NULL);
	}

	CloseHandle(hFile__Input);
	CloseHandle(hFile__Output);

	if (IDYES == 
		AfxMessageBox(_T("The crypting finished.\nWould you like to open the crypted file and play it?"), MB_YESNO | MB_DEFBUTTON1))
		PlayCryptedFlashFile(strOutputFile);
}

void CSample8_SecureFlashContentLoadingDlg::OnBnClickedPlay()
{
	CFileDialog dlg(TRUE, 
					_T("crypted"), 
					_T(""), 
					0, 
					_T("Crypted Flash files (*.crypted)|*.crypted|All Files (*.*)|*.*||"), 
					this, 
					0);

	if (IDOK == dlg.DoModal())
		PlayCryptedFlashFile(dlg.GetPathName());
}

void CSample8_SecureFlashContentLoadingDlg::PlayCryptedFlashFile(LPCTSTR lpszPath)
{
	// Read and decrypt first three bytes to determinate the type of this file (flash movie or flash video)
	HANDLE hFile = CreateFile(lpszPath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);

	char Buffer[3] = { 0 };
	DWORD dwNumberOfBytesRead;

	ReadFile(hFile, Buffer, sizeof(Buffer), &dwNumberOfBytesRead, NULL);

	CloseHandle(hFile);

	// Decrypt
	for (int i = 0; i < sizeof(Buffer); i++)
		Buffer[i] ^= 0x06;

	g_strFlashFilePath = lpszPath;

	if ('F' == Buffer[0] && 'L' == Buffer[1] && 'V' == Buffer[2])
	{
		// Flash video
		FPCPutMovieFromResource(m_hwndFlashPlayerControl, NULL, _T("FLVPLAYER"), _T("SWF"));
	}
	else
		// Flash movie
	{
		CComPtr<IStream> pStream;
		FPCPutMovieUsingStream(m_hwndFlashPlayerControl, &pStream);

		DWORD dwThreadId;
		HANDLE hThread = CreateThread(NULL, 0, &FlashContentProviderThread, (LPVOID)pStream.Detach(), 0, &dwThreadId);
		CloseHandle(hThread);
	}
}

HRESULT WINAPI GlobalOnLoadExternalResourceHandler(LPCSTR lpszURL, IStream** ppStream)
{
	if (0 == lstrcmpiA(lpszURL, "http://FLV/FlashVideo.flv"))
	{
		IStream* pStream = *ppStream;
		pStream->AddRef();

		DWORD dwThreadId;
		HANDLE hThread = CreateThread(NULL, 0, &FlashContentProviderThread, (LPVOID)pStream, 0, &dwThreadId);
		CloseHandle(hThread);

		return S_ASYNCHRONOUS;
	}

	return S_FALSE;
}

DWORD WINAPI FlashContentProviderThread(LPVOID lpParameter)
{
	IStream* pStream = (IStream*)lpParameter;

	HANDLE hFile = CreateFile(g_strFlashFilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);

	char Buffer[1024];

	while (true)
	{
		DWORD nRead = 0;
		BOOL bRes = ReadFile(hFile, Buffer, sizeof(Buffer), &nRead, NULL);

		if (!bRes || 0 == nRead)
			break;

		// Decrypt
		for (DWORD i = 0; i < nRead; i++)
			Buffer[i] ^= 0x06;

		DWORD nWritten = 0;
		pStream->Write(Buffer, nRead, &nWritten);
	}

	CloseHandle(hFile);

	pStream->Release();

	return 1;
}
